/* -*- C++ -*-
 * $Id: flvtable.h,v 1.1 2002/10/21 16:12:11 ttate Exp $
 */

#ifndef RBFLVTABLE_H
#define RBFLVTABLE_H

/*
 * select macro is defined in ruby-x.x.x/win32/win32.h.
 * This definition conflicts with Fl_Browser::select.
 *                                  Thanks Lorien Dunn
 */
#ifdef select
# undef select
#endif

#include <ruby.h>
#include "flvlist.h"
#include <FL/Flv_Table.H>
#include "flvstyle.h"

class RBFLVTable : public Flv_Table, public RBFLVListInternalWidgetsMask 
{
public:
  VALUE rb_col_style;
  RBFLVTable(int x, int y, int w, int h, const char *label = 0)
    : Flv_Table(x,y,w,h,label),RBFLVListInternalWidgetsMask(){
	init_RBFLVListInternalWidgetsMask((RBFLVList*)this);
	rb_col_style = Data_Wrap_Struct(rb_cFLVStyleList,0,0,&col_style);
	rb_gc_register_address(&rb_col_style);
  };
  ~RBFLVTable(){
    rb_gc_unregister_address(&rb_col_style);
  }
  RBFL_CALLERS(Flv_Table);

  virtual int col_width(int c) {
    VALUE obj = fl_to_rb((Fl_Widget*)this);
    VALUE ret = rb_funcall(obj, rb_intern("col_width"), 1, INT2FIX(c));
    return FIX2INT(ret);
  };

  int call_parent_col_width(int c) {
    return Flv_Table::col_width(c);
  };

  virtual int col_width(int n, int c) {
    VALUE obj = fl_to_rb((Fl_Widget*)this);
    VALUE ret = rb_funcall(obj, rb_intern("col_width"), 2, INT2FIX(n), INT2FIX(c));
    return FIX2INT(ret);
  };

  int call_parent_col_width(int n, int c) {
    return Flv_Table::col_width(n,c);
  };

  virtual void get_style(Flv_Style &s, int R, int C=0){	//	get trickle down style
    VALUE obj = fl_to_rb((Fl_Widget*)this);
    VALUE style = Data_Wrap_Struct(rb_cFLVStyle,0,0,&s);
    rb_gc_register_address(&style);
    rb_funcall(obj, rb_intern("get_style"), 3, style, INT2FIX(R), INT2FIX(C));
    rb_gc_unregister_address(&style);
  }

  void call_parent_get_style(Flv_Style &s, int R, int C=0){	//	get trickle down style
    Flv_Table::get_style(s,R,C);
  }

  virtual void draw_row( int Offset, int &X, int &Y, int &W, int &H, int R ){
    VALUE rc, obj = fl_to_rb((Fl_Widget*)this);
    rc = rb_funcall(obj, rb_intern("draw_row"), 6, INT2FIX(Offset), INT2FIX(X), INT2FIX(Y), 
	INT2FIX(W), INT2FIX(H), INT2FIX(R));
  }

  void call_parent_draw_row( int Offset, int &X, int &Y, int &W, int &H, int R ){
    Flv_Table::draw_row( Offset, X, Y, W, H, R );
  }

  virtual void draw_cell( int Offset, int &X, int &Y, int &W, int &H, int R, int C){
    VALUE rc, obj = fl_to_rb((Fl_Widget*)this);
    rc = rb_funcall(obj, rb_intern("draw_cell"), 7, INT2FIX(Offset), INT2FIX(X), INT2FIX(Y), 
	INT2FIX(W), INT2FIX(H), INT2FIX(R), INT2FIX(C));
  }

  void call_parent_draw_cell( int Offset, int &X, int &Y, int &W, int &H, int R, int C ){
    Flv_Table::draw_cell( Offset, X, Y, W, H, R , C);
  }
};

extern "C" void Init_flvtable(void);

#endif /* RBFLVTABLE_H */
