# $Id: alert.rb,v 1.4 2006/12/31 11:58:23 jeremy_henty Exp $

# This program is a part of the Ruby/FLTK tests.
# Author:: Jeremy Henty <mailto:jeremy_henty@users.sourceforge.net>
# Copyright:: Copyright (c) 2006 Jeremy Henty 
# License:: LGPL

=begin

Demonstrate FLTK.alert (which passes its arguments to sprintf) and
FLTK.alert0 (which does not).

=end

require 'fltk'

stuff =
  [ [ :alert0, ], 
    [ :alert0, "Hello!", ], 
    [ :alert0, 
      "This is not a format, even though it contains a '%'!", ], 
    [ :alert0, 
      "A '%S' looks like a bad format, " +
      "but this is just a string, so it's OK.", ], 
    [ :alert0,
      "Too many arguments", "y'know?", ], 
    [ :alert, ], 
    [ :alert, "This string is actually a format!", ], 
    [ :alert, 
      "This format interpolates the string '%s' and the number %d.", 
      "Grand Wazoo", 42, ], 
    [ :alert, 
      "A '%S' makes this string a bad format, " +
      "so it will raise an error.", ], 
    [ :alert,
      "Too few format arguments (%s %s).", "hmm?", ], 
  ]

button_height = 30
win_height = stuff.size * button_height
FLTK::Window.new(800,win_height,"Alerts"){|win|
  FLTK::Pack.new(win.w,1){|pack|
    pack.pack_type(FLTK::VERTICAL)
    stuff.each{|_m,*_a|
      label = "FLTK.%s(%s)" %
      [ _m, _a.collect{|_a0| _a0.inspect }.join(","), ]
      button = FLTK::Button.new(0,button_height,label){
        begin FLTK.send(_m,*_a)
        rescue => err ; FLTK.alert("Error: %s",err)
        end
        }
      button.align(FLTK::ALIGN_INSIDE |
                   FLTK::ALIGN_LEFT   )
    }
  }
  win.show
}

FLTK.run
