# $Id: buttons.rb,v 1.3 2006/12/31 11:58:23 jeremy_henty Exp $

require 'fltk'

def message(string)
  @message_box.label(string)
end

FLTK::Window.new(450,150,'Buttons'){|win|
  FLTK::Pack.new(win.w,win.h){|pack0|
    pack0.pack_type(FLTK::VERTICAL)
    FLTK::Pack.new(win.w,120){|pack1|
      pack1.pack_type(FLTK::HORIZONTAL)

      FLTK::Pack.new(150,pack1.h){|pack2|
        pack2.pack_type(FLTK::VERTICAL)

        [ "Button", "ReturnButton", ].each{|_class|
          FLTK.const_get(_class).new(0,30,_class){
            message(_class)
          }
        }

        repeat_count = 0
        FLTK::RepeatButton.new(0,30,"RepeatButton"){
          repeat_count += 1
          message("RepeatButton: #{repeat_count}")
        } 

      }

      FLTK::Pack.new(150,pack1.h){|pack3|
        pack3.pack_type(FLTK::VERTICAL)
        [ "CheckButton", 
          "LightButton", 
          "RoundButton", 
          "ToggleButton", 
        ].each{|_class|
          button = FLTK.const_get(_class).new(0,30,_class){
            value = (button.value == 1) ? "on" : "off"
            message("#{_class}: #{value}")
          }
        }
      }

      FLTK::Pack.new(150,pack1.h){|pack4|
        pack4.pack_type(FLTK::VERTICAL)
        (1..4).each{|i0|
          button = FLTK::Button.new(0,30,"Radio #{i0}"){
            message("Radio #{i0}")
          }
          button.button_type(FLTK::RADIO_BUTTON)
        }
      }

    }

    @message_box = FLTK::Box.new(0,30)
    @message_box.box(FLTK::DOWN_BOX)
  }
  win.show
}

FLTK.run
