# $Id: deprecated.rb,v 1.6 2006/12/31 11:58:24 jeremy_henty Exp $

# This program is a part of the Ruby/FLTK tests.
# Author:: Jeremy Henty <mailto:jeremy_henty@users.sourceforge.net>
# Copyright:: Copyright (c) 2006 Jeremy Henty 
# License:: LGPL

require 'fltk'

y = 0
legend_y = y ; legend_height = 80 ; y += legend_height
title_y  = y ; title_height  = 30 ; y += title_height
row_0_y  = y ; row_0_height  = 30 ; y += row_0_height
y += 10
row_1_y  = y ; row_1_height  = 30 ; y += row_1_height
y += 10
row_2_y  = y ; row_2_height  = 30 ; y += row_2_height
y += 10
window_height = y

x = 0
x += 10 
col_0_left = x ; col_0_width =  80 ; x += col_0_width
x += 10 
col_1_left = x ; col_1_width = 130 ; x += col_1_width
x += 10
window_width = x

class Clip_Window_ < FLTK::Window
  def initialize
    super(200,200,"FLTK.#{clip_method}")
  end
  def draw
    margin = 20
    FLTK.send(clip_method,
              margin,
              margin,
              w-2*margin,
              h-2*margin){
      super
      FLTK.font(FLTK::HELVETICA,15)
      FLTK.color(FLTK::BLACK)
      text = "This text was clipped by 'FLTK.#{clip_method}'. " * 2
      20.times{|ii| FLTK.draw(text,-20*ii,15*ii) }
    }
  end
end

class Clip_Window < Clip_Window_
  def clip_method ; :clip ; end
end

class Push_Clip_Window < Clip_Window_
  def clip_method ; :push_clip ; end
end

clip_window =
  Clip_Window.new
push_clip_window =
  Push_Clip_Window.new

legend =
  [ "The first use of a deprecated", 
    "method sends a warning to",
    "standard error. Use the", 
    "preferred method instead.", 
  ].join("\n")

FLTK::Window.new(window_width,
                 window_height,
                 "Deprecated"){|win|
  b = FLTK::Box.new(5,legend_y,
                    205,legend_height,
                    legend)
  b.align(FLTK::ALIGN_LEFT|
          FLTK::ALIGN_INSIDE)
  FLTK::Box.new(col_0_left,title_y,
                col_0_width,title_height,
                "Deprecated")
  FLTK::Box.new(col_1_left,title_y,
                col_1_width,title_height,
                "Preferred")
  FLTK::Button.new(col_0_left,row_0_y,
                   col_0_width,row_0_height,
                   "FLTK.ask0"){
    answer = 
    FLTK.ask0("Cookie?") ? "yes" : "no"
    FLTK.message("Answer: %s",answer) 
  }
  FLTK::Button.new(col_1_left,row_0_y,
                   col_1_width,row_0_height,
                   "FLTK.choice0"){
    answer = case FLTK.choice0("Cookie?","No","Yes")
             when 0: "no"
             when 1: "yes"
             end
    FLTK.message("Answer: %s",answer) 
  }
  FLTK::Button.new(col_0_left,row_1_y,
                   col_0_width,row_1_height,
                   "FLTK.ask"){
    answer = 
    FLTK.ask("Would you like a %s?","cookie") ? "yes" : "no"
    FLTK.message("Answer: %s",answer) 
  }
  FLTK::Button.new(col_1_left,row_1_y,
                   col_1_width,row_1_height,
                   "FLTK.choice"){
    answer = case FLTK.choice("Would you like a %s?",
                              "No","Yes",nil,"cookie")
             when 0: "no"
             when 1: "yes"
             end
    FLTK.message("Answer: %s",answer) 
  }
  FLTK::Button.new(col_0_left,row_2_y,
                   col_0_width,row_2_height,
                   "FLTK.clip"){
    clip_window.show
  }
  FLTK::Button.new(col_1_left,row_2_y,
                   col_1_width,row_2_height,
                   "FLTK.push_clip"){
    push_clip_window.show
  }
  win.show
}

FLTK.run
