# $Id: draw_xy.rb,v 1.3 2006/12/31 11:58:24 jeremy_henty Exp $

require 'fltk'

# test FLTK.xyline , FLTK.yxline 

# MyWidget.draw makes several calls like:
#   FLTK.xyline(x,y,x+d,y+d,x+2*d,y+2*d,...)
#   FLTK.yxline(x,y,y+d,x+d,y+2*d,x+2*d,...)
# Between each call it increments all the x-coordinates so that the
# successive drawing calls won't overlap.

class MyWidget < FLTK::Widget
  def draw
    FLTK.color(FLTK::GRAY)
    FLTK.rectf(x,y,w,h)
    FLTK.color(FLTK::BLACK) 
    FLTK.push_clip(x,y,w,h){
      _d = 20

      # test FLTK.xyline 
      args = [x+_d,y+_d,x+2*_d,]
      8.times {
        FLTK.xyline(*args)
        # increment the x-coords 
        args.size.times{|_i| 
          args[_i] += 2*_d if
          _i % 2 == 0
        }
        args << args[-2] + _d # add a new line 
      }

      # test FLTK.yxline 
      args = [y+6*_d,x+_d,y+7*_d,]
      8.times {
        FLTK.yxline(args[1],args[0],*args[2..-1])
        # increment the x-coords 
        args.size.times{|_i|
          args[_i] += 2*_d if
          _i % 2 == 1
        }
        args << args[-2] + _d # add a new line 
      }

    }
  end
end

FLTK::Window.new(500,300,"xyline & yxline"){|win|
  MyWidget.new(win.w,win.h)
  win.show
}

FLTK.run
