# $Id: image.rb,v 1.9 2006/12/31 11:58:24 jeremy_henty Exp $

require 'fltk'

def make_image(w, h)
  (0...h).collect do |y|
    dy = y.to_f / (h - 1)
    (0...w).collect do |x| 
      dx = x.to_f / (w - 1)
      [ (1-dx)*(1-dy),
        (1-dx)*dy, 
        dx*dy, 
        ].collect do |t|
        (255*t).to_i
      end
    end
  end.flatten
end

class MyBox < FLTK::Box
  def initialize(*)
    super
    width = 75
    height = 75
    image(FLTK::RGBImage.new(make_image(width,height),width,height))
  end
end

FLTK::Window.new(100,100,"Image"){|win|
  MyBox.new(win.w,win.h)
  win.show
}

FLTK.run
