# $Id: list.rb,v 1.10 2006/12/31 11:58:24 jeremy_henty Exp $

require 'fltk'
require 'flvw'

#//	Demonstrate Simplest Flv_List_Child

class VListChild < FLTK::VList
  include FLTK::Drawable
  def initialize(px, py, pw, ph, l='')
    super(px,py,pw,ph,l)
  end

  def draw_row( offset, px, py, pw, ph, pr )
    style = FLTK::VStyle.new
    get_style(style, pr,0)
    super
    if pr < 0
      line = ((pr == -1) ? 'Header' : 'Footer')
    else
      line = pr.to_s
    end
    text_draw(line, px+1-offset, py-8,pw,ph-4, style.align)
  end
end

FLTK::Window.new( 200, 173, "Test list" ){|win|
  l = VListChild.new( 10, 10, 180, 153 )
  win.end
  win.resizable(l)

  l.rows(20)
  l.has_scrollbar(FLTK::VS_VERTICAL)
  #l.row_width(200)
  #l.feature(FLTK::VF_ALL_ROW | FLTK::VF_MULTI_SELECT)
  l.global_style.resizable(true)
  l.global_style.align(FLTK::ALIGN_CLIP)
  #  l.global_style.border(FLTK::VB_RIGHT | FLTK::VB_BOTTOM)

  l.callback(l){|pw,pd| FLTK.message0("Hi")}

  win.show
}

FLTK.run
