# $Id: menus.rb,v 1.9 2006/12/31 11:58:24 jeremy_henty Exp $

require 'fltk'

message = nil # will set this later 
pr = proc{ |o, d| message.label(o.text) }

items =
  [
   ["&Shortcuts", 0, nil, 0, FLTK::SUBMENU],
   ["&Open", FLTK::CTRL + ?o, pr],
   ["&Save", FLTK::CTRL + ?s, pr, 0, FLTK::MENU_DIVIDER|FLTK::MENU_INACTIVE],
   ["&Quit", FLTK::CTRL + ?q, proc{ exit }],
   [],
   ["&Radios", 0, nil, 0, FLTK::SUBMENU],
   ["One", 0, pr, 0, FLTK::MENU_RADIO|FLTK::MENU_VALUE],
   ["Two", 0, pr, 0, FLTK::MENU_RADIO],
   ["Three", 0, pr, 0, FLTK::MENU_RADIO|FLTK::MENU_DIVIDER],
   ["Four", 0, pr, 0, FLTK::MENU_RADIO|FLTK::MENU_VALUE],
   ["Five", 0, pr, 0, FLTK::MENU_RADIO],
   [],
   ["&Checks", 0, nil, 0, FLTK::SUBMENU],
   ["One", 0, pr, 0, FLTK::MENU_TOGGLE|FLTK::MENU_VALUE],
   ["Two", 0, pr, 0, FLTK::MENU_TOGGLE],
   ["Three", 0, pr, 0, FLTK::MENU_TOGGLE|FLTK::MENU_DIVIDER],
   ["Four", 0, pr, 0, FLTK::MENU_TOGGLE],
   ["Five", 0, pr, 0, FLTK::MENU_TOGGLE],
   [],
   ["F&ont", 0, nil, 0, FLTK::SUBMENU],
   ["Shadow", 0, pr, 0, 0, FLTK::SHADOW_LABEL],
   ["Engraved", 0, pr, 0, 0, FLTK::ENGRAVED_LABEL],
   ["Embossed", 0, pr, 0, FLTK::MENU_DIVIDER, FLTK::EMBOSSED_LABEL],
   ["Bold", 0, pr, 0, 0, 0, FLTK::BOLD],
   ["Italic", 0, pr, 0, FLTK::MENU_DIVIDER, 0, FLTK::ITALIC],
   ["Small", 0, pr, 0, 0, 0, 0, 10],
   ["Big", 0, pr, 0, FLTK::MENU_DIVIDER, 0, 0, 24],
   ["Red", 0, pr, 0, 0, 0, 0, 0, FLTK::RED],
   ["Saddlebrown", 0, pr, 0, 0, 0, 0, 0, FLTK.rgb_color(139, 69, 19)],
   [],
  ]

FLTK.background(200, 203, 194)
FLTK.foreground(30, 30, 90)
FLTK.background2(240, 240, 240)

FLTK::Window.new(400, 230, "#{$0}"){ |win|

  o = FLTK::MenuBar.new(0, 0, win.w, 30)
  o.box=FLTK::THIN_UP_BOX
  o.menu=items

  o = FLTK::Choice.new(90, 36, 100, 30, "Choice:")
  o.align=FLTK::ALIGN_LEFT
  o.box=FLTK::THIN_UP_BOX
  o.menu=items

  o = FLTK::MenuButton.new(210, 36, 120, 30, "MenuButton")
  o.align=FLTK::ALIGN_LEFT|FLTK::ALIGN_INSIDE
  o.color=FLTK.darker(FLTK::BACKGROUND_COLOR)
  o.box=FLTK::THIN_UP_BOX
  o.menu=items

  o = FLTK::MenuButton.new(0, 70, 400, 130)
  o.box=FLTK::BORDER_BOX
  o.color=FLTK.lighter(FLTK::BACKGROUND_COLOR)
  o.widget_type=FLTK::MenuButton::POPUP3
  o.menu=items

  o = FLTK::Box.new(0, 70, 400, 130, "Press right button\nfor a pop-up menu")
  o.box=FLTK::ENGRAVED_BOX

  message = FLTK::Box.new(0, 200, 400, 30)

  win.show
}

FLTK.run
