# $Id: progress.rb,v 1.7 2006/12/31 11:58:24 jeremy_henty Exp $

require 'fltk'

class Progress < FLTK::Progress

  def initialize(*)
    super
    maximum(100.0)
    minimum(0.0)
    value(50.0)
    selection_color(FLTK::BLUE)
    update
  end

  def delta(_delta)
    self.value += _delta
    update
  end

  def update
    label(((value/maximum)*100).to_s + "%")
  end

end

prog = nil # set this later 
FLTK::Window.new(300,100,'Progress Bar'){|win|
  FLTK::Pack.new(25,25,250,50){|pack1|
    pack1.packtype = FLTK::Pack::VERTICAL
    FLTK::Pack.new(250,25){|pack2|
      pack2.packtype = FLTK::Pack::HORIZONTAL
      FLTK::Button.new(125,20,"UP"){prog.delta(+10.0)}
      FLTK::Button.new(125,20,"DOWN"){prog.delta(-10.0)}
    }
    prog = Progress.new(200,20)
  }
  win.show
}

FLTK.run
