# $Id: timeout.rb,v 1.11 2007/01/08 04:46:42 jeremy_henty Exp $

require 'fltk'

class Timeout

  attr_reader \
  :count, :cb_count,
  :count_box, :cb_count_box

  def initialize(_cb_count_box,
                 _count_box)
    @cb_count_box = _cb_count_box
    @count_box    = _count_box
    self.count    = 0
    self.cb_count = 0
  end

  def count= _count
    @count = _count
    count_box.label(count.to_s)
  end

  def cb_count= _cb_count
    @cb_count = _cb_count
    cb_count_box.label(cb_count.to_s)
  end

end

callback = Proc.new {|timeout|
  timeout.count += 1
  FLTK.repeat_timeout(1.0,callback,timeout)
}

_x = 0
x0 = _x; _x += w0 = 40
x1 = _x; _x += w1 = 70
x2 = _x; _x += w2 = 30
x3 = _x; _x += w3 = 30

timeout_count = 3

_y = 0 ; _h = 30 ; _w = timeout_count*_h
FLTK::Window.new(_x,_w,"Timeout"){|win| 
  timeout_count.times {
    add_button = FLTK::Button.new(x0,_y,w0,_h,"Add")
    remove_button = FLTK::Button.new(x1,_y,w1,_h,"Remove")
    timeout = Timeout.new(FLTK::Box.new(x2,_y,w2,_h),
                          FLTK::Box.new(x3,_y,w3,_h))
    add_button.callback {
      FLTK.add_timeout(1.0,callback,timeout)
      timeout.cb_count += 1
    }
    remove_button.callback {
      FLTK.remove_timeout(callback,timeout)
      timeout.cb_count = 0
    }
    _y += _h
  }
  win.show
}

FLTK.run
